module SigHeap where

class Heap t where
   empty     :: Ord a => t a
   isEmpty   :: Ord a => t a -> Bool
   minElem   :: Ord a => t a -> a
   deleteMin :: Ord a => t a -> t a
   insert    :: Ord a => a -> t a -> t a 
   merge     :: Ord a => t a -> t a -> t a
   fromHeap  :: Ord a => t a -> [a]
   fromHeap h = if isEmpty h then []
                             else minElem h : fromHeap (deleteMin h) 
